#include "testlib.h"
#include <numeric>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), l = opt<int>("l");
    bool allow_one = opt<bool>("one");
    int k = has_opt("k") ? opt<int>("k") : 3;

    vector<int> p(n);
    vector<vector<int>> layers(l);
    layers[0].push_back(0);
    int layer_size = (n - 1) / (l - 1);
    for (int layer = 1; layer < l; layer++) {
        int start = layers[layer - 1].back() + 1;
        shuffle(layers[layer - 1].begin(), layers[layer - 1].end());
        int rem = min({layer_size / 2, (n - start + 1) / 2, (int) layers[layer - 1].size()});
        int twos = rem;
        int ones = allow_one ? rnd.next(0, rem / 2) : 0;
        twos -= ones;
        vector<int> d(ones + twos, 1);
        for (int i = 0; i < twos; i++) d[i] = 2;
        shuffle(d.begin(), d.end());
        for (int cur = 0; cur < d.size(); cur++) {
            for (int _ = 0; _ < d[cur]; _++) {
                layers[layer].push_back(start);
                p[start] = layers[layer - 1][cur] + 1;
                start++;
            }
        }
    }

    int s = layers.back().back() + 1;
    println(s, k);
    println(p.begin() + 1, p.begin() + s);

}