/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

typedef vector<vector<int>> graph;

int k;
graph g;
vector<pll> dp;
ll const MOD = 1000'000'007;

ll dp_full(int v) {
    return dp[v].first + dp[v].second;
}

void dfs(int v) {
    dp[v].first = 1;
    for (int u : g[v]) {
        dfs(u);
        dp[v].first = dp[v].first * dp_full(u) % MOD;
    }
    if (g[v].size() < 2) return;

    vector<ll> left(k + 1);
    left[0] = 1ll;
    for (int i = 0; i < g[v].size(); i++) {
        for (int j = min(k, i + 1); j > 0; j--) {
            left[j] = (left[j] * dp_full(g[v][i]) + left[j - 1] * dp[g[v][i]].first) % MOD;
        }
        left[0] = left[0] * dp_full(g[v][i]) % MOD;
    }
    for (int t = 2; t <= k; t++) {
        dp[v].second += left[t];
    }
}

int main() {

    in(int, n)
    cin >> k;
    k--;

    g.resize(n);
    for (int i = 1; i < n; i++) {
        in(int, p)
        g[--p].push_back(i);
    }

    dp.resize(n);
    dfs(0);
    cout << dp_full(0) % MOD << '\n';

}